#pragma once

#include <SDL2/SDL_blendmode.h>  // for SDL_BlendMode
#include <SDL2/SDL_pixels.h>     // for SDL_PIXELFORMAT_RGBA8888, SDL_PixelF...
#include <SDL2/SDL_rect.h>       // for SDL_Point, SDL_Rect
#include <SDL2/SDL_render.h>     // for SDL_Renderer, SDL_FLIP_NONE, SDL_TEX...
#include <SDL2/SDL_stdinc.h>     // for Uint8, Uint32
#include <string>                // for string
#include <vector>                // for vector
struct Color;  // lines 11-11

class Texture
{
private:
    // Objetos y punteros
    SDL_Renderer *renderer_;                     // Renderizador donde dibujar la textura
    SDL_Texture *texture_ = nullptr;             // La textura

    // Variables
    std::string path_;                          // Ruta de la imagen de la textura
    int width_ = 0;                             // Ancho de la imagen
    int height_ = 0;                            // Alto de la imagen
    std::vector<std::vector<Uint32>> palettes_; // Vector con las diferentes paletas

    // Libera la memoria de la textura
    void unloadTexture();

public:
    // Constructor
    explicit Texture(SDL_Renderer *renderer, const std::string &path = std::string());

    // Destructor
    ~Texture();

    // Carga una imagen desde un fichero
    bool loadFromFile(const std::string &path);

    // Crea una textura en blanco
    bool createBlank(int width, int height, SDL_PixelFormatEnum format = SDL_PIXELFORMAT_RGBA8888, SDL_TextureAccess = SDL_TEXTUREACCESS_TARGET);

    // Establece el color para la modulacion
    void setColor(Uint8 red, Uint8 green, Uint8 blue);
    void setColor(Color color);

    // Establece el blending
    void setBlendMode(SDL_BlendMode blending);

    // Establece el alpha para la modulación
    void setAlpha(Uint8 alpha);

    // Renderiza la textura en un punto específico
    void render(int x, int y, SDL_Rect *clip = nullptr, float zoomW = 1, float zoomH = 1, double angle = 0.0, SDL_Point *center = nullptr, SDL_RendererFlip flip = SDL_FLIP_NONE);

    // Establece la textura como objetivo de renderizado
    void setAsRenderTarget(SDL_Renderer *renderer);

    // Obtiene el ancho de la imagen
    int getWidth();

    // Obtiene el alto de la imagen
    int getHeight();

    // Recarga la textura
    bool reLoad();

    // Obtiene la textura
    SDL_Texture *getSDLTexture();

    // Obtiene el renderizador
    SDL_Renderer *getRenderer();
};